{
  lib,
  pkgs,
  config,
  ...
}: let
  pkgsRepositories = pkgs.nix-vscode-extensions.forVSCodeVersion config.programs.vscode.package.version;
  pkgsRepository = pkgsRepositories.open-vsx;
in {
  options.programs.vscode.profiles = lib.mkOption {
    type = lib.types.attrsOf (lib.types.submodule ({config, ...}: {
      options = {
        extraExtensions.atomKeybindings = {
          enable = lib.mkEnableOption "should the atom keybindings extension for vscode be enabled";
          extension = lib.mkPackageOption pkgsRepository "atom-keybindings" {
            default = ["ms-vscode" "atom-keybindings"];
          };
        };
      };
      config = lib.mkIf config.extraExtensions.atomKeybindings.enable {
        extensions = [
          config.extraExtensions.atomKeybindings.extension
        ];
      };
    }));
  };
}
