{
  lib,
  pkgs,
  config,
  ...
}: let
  pkgsRepositories = pkgs.nix-vscode-extensions.forVSCodeVersion config.programs.vscode.package.version;
  pkgsRepository = pkgsRepositories.open-vsx;
in {
  options.programs.vscode.profiles = lib.mkOption {
    type = lib.types.attrsOf (lib.types.submodule ({config, ...}: {
      options = {
        extraExtensions.autoRenameTag = {
          enable = lib.mkEnableOption "should the auto-rename-tag extension for vscode be enabled";
          extension = lib.mkPackageOption pkgsRepository "auto-rename-tag" {
            default = ["formulahendry" "auto-rename-tag"];
          };
        };
      };
      config = lib.mkIf config.extraExtensions.autoRenameTag.enable {
        extensions = [
          config.extraExtensions.autoRenameTag.extension
        ];
      };
    }));
  };
}
