{
  lib,
  pkgs,
  config,
  ...
}: let
  pkgsRepositories = pkgs.nix-vscode-extensions.forVSCodeVersion config.programs.vscode.package.version;
  pkgsRepository = pkgsRepositories.open-vsx;
in {
  options.programs.vscode.profiles = lib.mkOption {
    type = lib.types.attrsOf (lib.types.submodule ({config, ...}: {
      options = {
        extraExtensions.es7ReactJsSnippets = {
          enable = lib.mkEnableOption "should the es7-react-js-snippets extension for vscode be enabled";
          extension = lib.mkPackageOption pkgsRepository "es7-react-js-snippets" {
            default = ["dsznajder" "es7-react-js-snippets"];
          };
        };
      };
      config = lib.mkIf config.extraExtensions.es7ReactJsSnippets.enable {
        extensions = [
          config.extraExtensions.es7ReactJsSnippets.extension
        ];
      };
    }));
  };
}
