{
  lib,
  pkgs,
  config,
  ...
}: let
  pkgsRepositories = pkgs.nix-vscode-extensions.forVSCodeVersion config.programs.vscode.package.version;
  pkgsRepository = pkgsRepositories.open-vsx;
in {
  options.programs.vscode.profiles = lib.mkOption {
    type = lib.types.attrsOf (lib.types.submodule ({config, ...}: {
      options = {
        extraExtensions.liveServer = {
          enable = lib.mkEnableOption "should the live-server extension for vscode be enabled";
          extension = lib.mkPackageOption pkgsRepository "live-server" {
            default = ["ms-vscode" "live-server"];
          };
        };
      };
      config = lib.mkIf config.extraExtensions.liveServer.enable {
        extensions = [
          config.extraExtensions.liveServer.extension
        ];
      };
    }));
  };
}
