{
  lib,
  pkgs,
  config,
  ...
}: let
  pkgsRepositories = pkgs.nix-vscode-extensions.forVSCodeVersion config.programs.vscode.package.version;
  pkgsRepository = pkgsRepositories.open-vsx;
in {
  options.programs.vscode.profiles = lib.mkOption {
    type = lib.types.attrsOf (lib.types.submodule ({config, ...}: {
      options = {
        extraExtensions.tauriVscode = {
          enable = lib.mkEnableOption "should the tauri-vscode extension for vscode be enabled";
          extension = lib.mkPackageOption pkgsRepository "tauri-vscode" {
            default = ["tauri-apps" "tauri-vscode"];
          };
        };
      };
      config = lib.mkIf config.extraExtensions.tauriVscode.enable {
        extensions = [
          config.extraExtensions.tauriVscode.extension
        ];
      };
    }));
  };
}
