{
  lib,
  pkgs,
  config,
  ...
}: let
  pkgsRepositories = pkgs.nix-vscode-extensions.forVSCodeVersion config.programs.vscode.package.version;
  pkgsRepository = pkgsRepositories.open-vsx;
in {
  options.programs.vscode.profiles = lib.mkOption {
    type = lib.types.attrsOf (lib.types.submodule ({config, ...}: {
      options = {
        extraExtensions.vscodeEslint = {
          enable = lib.mkEnableOption "should the vscode-eslint extension for vscode be enabled";
          extension = lib.mkPackageOption pkgsRepository "vscode-eslint" {
            default = ["dbaeumer" "vscode-eslint"];
          };
        };
      };
      config = lib.mkIf config.extraExtensions.vscodeEslint.enable {
        extensions = [
          config.extraExtensions.vscodeEslint.extension
        ];
      };
    }));
  };
}
