{
  lib,
  pkgs,
  config,
  ...
}: let
  pkgsRepositories = pkgs.nix-vscode-extensions.forVSCodeVersion config.programs.vscode.package.version;
  pkgsRepository = pkgsRepositories.open-vsx;
in {
  options.programs.vscode.profiles = lib.mkOption {
    type = lib.types.attrsOf (lib.types.submodule ({config, ...}: {
      options = {
        extraExtensions.vscodeStylelint = {
          enable = lib.mkEnableOption "should the vscode-stylelint extension for vscode be enabled";
          extension = lib.mkPackageOption pkgsRepository "vscode-stylelint" {
            default = ["stylelint" "vscode-stylelint"];
          };
        };
      };
      config = lib.mkIf config.extraExtensions.vscodeStylelint.enable {
        extensions = [
          config.extraExtensions.vscodeStylelint.extension
        ];
      };
    }));
  };
}
